﻿init python:
    from copy import copy
    class catwalk_item:
        def __init__(self, name, image, info):
            self.name = name
            self.image = image
            self.info = info
    class catwalk_cat:
        def __init__(self, name, image):
            self.name = name
            self.image = image
            self.tile = 0
            self.x = 0
            self.y = 0

            self.team = [self]
            self.health = 100
            self.max_health = 100
        
        def healed(self, amount):
            self.health += amount
            if self.health > self.max_health:
                self.health = self.max_health
        def damaged(self, amount):
            self.health -= amount
            if self.health < 0:
                self.health = 0
    class catwalk_dice:
        def __init__(self):
            self.x = 0
            self.y = 0
            self.alpha = 1
            self.number = 1
            self.rolling = 1
            self.available = True
        def roll(self):
            self.number = random.randint(1,6)
            self.rolling += 1
            if self.rolling > 20:
                self.rolling = 0
        def start_rolling(self):
            self.rolling = 1
        def throw(self):
            self.rolling = 0
            self.available = False
            self.x = random.randint(-10,10)
            self.y = -40
            self.alpha = 0
    class catwalk_tile:
        def __init__(self, x, y, tile = None, item = None):
            self.x = x
            self.y = y
            self.tile = tile
            self.item = item
            self.index = 0

    class catwalk_class:
        def __init__(self, tiles, items = [], all_cats = []):
            self.tiles = tiles
            for n,i in enumerate(self.tiles):
                i.index = n
            self.items = items
            self.all_cats = all_cats
            self.x = 32
            self.y = 16
            self.cats = []
            self.dices = [catwalk_dice(), catwalk_dice(), catwalk_dice()]
            self.playing_dice = 0
            self.spread()
        def spread(self, items = None):
            if not items:
                items = []
                for i in self.all_cats:
                    items.append(i)
                for j in self.items:
                    for i in range(j[0]):
                        items.append(copy(j[1]))
            for i in items:
                exit = 0
                while exit < 100:
                    exit += 1
                    tile = random.choice(self.tiles)
                    if not tile.item:
                        tile.item = i
                        break
        def choose_cat(self, cat):
            self.cats.append(cat)
            for i in self.tiles:
                if i.item:
                    if i.item in self.cats:
                        i.item = None
        def play(self, n):
            dice = self.dices[n]
            dice.throw()
            self.playing_dice = dice.number
            Show("catwalk_moving", g = self)()
        def fight_play(self, n):
            dice = self.dices[n]
            dice.throw()
            Show("catwalk_fight_attack", g = self)()
        def post_attack(self):
            Hide("catwalk_fight_attack")()
            self.re_dice()
        def move(self, backwards = False):
            cat = self.cats[0]
            if (backwards and cat.tile < 1) or cat.tile > len(self.tiles)-2:
                self.playing_dice = 0

            if self.playing_dice:
                renpy.play("catwalk/jump.ogg", "sound")
                self.playing_dice -= 1
                if backwards:
                    cat.tile -= 1
                else:
                    cat.tile += 1
                tile = self.tiles[cat.tile]
                cat.x = tile.x
                cat.y = tile.y
                if tile.item:
                    if type(tile.item) is str:
                        pass
                    elif tile.item.name == "Ball":
                        self.playing_dice = 0
            else:
                Hide("catwalk_moving")()
                Show("catwalk_check", g = self)()
                self.re_dice()
        def re_dice(self):
            for i in self.dices:
                if not i.available:
                    i.x = 0
                    i.y = 0
                    i.alpha = 1
                    i.start_rolling()
                    i.available = True
        def check_tile(self):
            tile = self.tiles[self.cats[0].tile]
            if tile.item:
                if  type(tile.item) is str:
                    pass
                elif type(tile.item) is catwalk_cat:
                    Show("catwalk_found_cat", g = self, cat = tile.item)()
                    self.cats[0].team.append(tile.item)
                    tile.item = None
                elif tile.item.name == "Tuna":
                    Show("catwalk_item", g = self, item = tile.item)()
                elif tile.item.name == "Box":
                    Show("catwalk_item", g = self, item = tile.item)()
                elif tile.item.name == "Ball":
                    Show("catwalk_item", g = self, item = tile.item)()
                elif tile.item.name == "Short snake":
                    Show("catwalk_item", g = self, item = tile.item)()
                elif tile.item.name == "Ouchy plant":
                    Show("catwalk_item", g = self, item = tile.item)()
                elif tile.item.name == "Scratchy":
                    Show("catwalk_item", g = self, item = tile.item)()
                elif tile.item.name == "Fight":
                    Show("catwalk_fight", g = self, enemies = [catwalk_fight])()
            Hide("catwalk_check")()
        def use_item(self, item):
            Hide("catwalk_item")()
            if item.name == "Tuna":
                for i in self.cats[0].team:
                    if i.health == i.max_health:
                        i.max_health += 10
                    i.healed(50)
            elif item.name == "Box":
                cat = self.cats[0]
                current_tile = self.tiles[cat.tile]
                tries = 0
                while tries < 100:
                    tries += 1
                    tile = random.choice(self.tiles)
                    if not tile.item:
                        tile.item = item
                        cat.x = tile.x
                        cat.y = tile.y
                        cat.tile = tile.index
                        current_tile.item = None
                        break
            elif item.name == "Ball":
                pass
            elif item.name == "Short snake":
                self.playing_dice = 10
                Show("catwalk_moving", g = self, backwards = True)()
            elif item.name == "Ouchy plant":
                for i in self.cats[0].team:
                    i.damaged(random.randint(20,50))
            elif item.name == "Scratchy":
                pass


screen catwalk_screen(g):
    modal True
    add "#378493"
    frame padding 0,0 xysize 352,100 align .5,.0 background None:
        at zoom(4, True)
        fixed fit_first True align .5,1.0:
            at catwalk_pound_offset(-g.cats[0].y*g.y)
            for i in reversed(g.tiles):
                button xysize 32,32 padding 0,0 align .5,1.0 offset i.x*g.x,i.y*g.y:
                    add i.tile 
                    if i.item:
                        if i.item in ["Start", "Boss"]:
                            pass
                        else:
                            add i.item.image align .5,.5

            if len(g.cats):
                for i in g.cats:
                    fixed xysize 32,32 align .5,1.0:
                        offset i.x*g.x,i.y*g.y
                        add i.image align .5,.5
        hbox:
            add "catwalk_pound_left"
            add "catwalk_pound_middle" yalign 1.0 yoffset -4
            add "catwalk_pound_right"
    frame:
        align .5,1.0 ysize 600
        background "#379e60"
    frame:
        align 1.0,.5 xsize 280
        background "#379e60"
    frame:
        align .0,.5 xsize 280
        background "#379e60"
    hbox align .5,.5 offset 0,-50 spacing 8:
        at zoom(4, True)
        for n,i in enumerate(g.dices):
            button padding 0,0:
                xysize 16,16 background None
                add f"catwalk_dice_{i.number}" at dice_move(i.x, i.y, i.alpha)
                action Function(g.play, n)
                if i.rolling:
                    timer .1 repeat True action Function(i.roll)
    hbox align .5,.8:
        for i in g.cats[0].team:
            vbox xsize 200:
                text f"{i.health} / {i.max_health}" align .5,.5 size 22
                bar value i.health range i.max_health xysize 128,10 align .5,.5
                add i.image at zoom(8, True) align .5,.5
                text i.name  align .5,.5

    vbox:
        text str(g.cats[0].tile)
        text str(len(g.tiles))

screen catwalk_moving(g, backwards = False):
    modal True
    timer .4 repeat True action Function(g.move, backwards)

screen catwalk_check(g):
    modal True
    timer .4 action Function(g.check_tile)
    text "Checking" align .5,.5

screen catwalk_choice(g):
    modal True
    fixed:
        at catwalk_fade
        add "#402040cc"
        vbox align .5,.5:
            text "Choose"
            frame background "#fff9" padding 20,20:
                hbox spacing 20:
                    for i in g.all_cats:
                        if not i in g.cats:
                            button background "#4449" xsize 200:
                                vbox align .5,.5:
                                    add i.image at zoom(8, True) align .5,.5
                                    text i.name align .5,.5
                                action Function(g.choose_cat, i), Return()

screen catwalk_fight(g, enemies):
    modal True
    fixed:
        at catwalk_fade
        add "#402040cc"
        vbox  align .5,.5 spacing 20:
            at zoom(8, True)
            hbox  align .5,.5 ysize 32:
                for i in enemies:
                    add i.image
            hbox align .5,.5:
                for n,i in enumerate(g.dices):
                    button padding 0,0:
                        xysize 16,16 background None
                        add f"catwalk_dice_{i.number}" at dice_move(i.x, i.y, i.alpha)
                        action Function(g.fight_play, n)
                        if i.rolling:
                            timer .1 repeat True action Function(i.roll)
            hbox align .5,.5 ysize 32:
                for i in g.cats[0].team:
                    add i.image
        fixed fit_first True align .5,.5:
            at zoom(8, True)
            add "catwalk_vs" at catwalk_vs_animation
        vbox align .5,1.0:
            text "The fight isn't ready yet."
            button:
                background "#402040cc" padding 20,20 align .5,.5
                text "Skip"
                action Hide("catwalk_fight")
screen catwalk_fight_attack(g):
    modal True
    timer 1 action Function(g.post_attack)

screen catwalk_found_cat(g, cat):
    modal True
    fixed:
        at catwalk_fade
        add "#402040cc"
        vbox align .5,.5:
            text "A friend joined your team!" align .5,.5
            add cat.image align .5,.5 at zoom(8, True)
            text cat.name align .5,.5
            button:
                background "#402040cc" padding 20,20 align .5,.5
                text "Nyaa"
                action Hide("catwalk_found_cat")

screen catwalk_item(g, item):
    modal True
    fixed:
        at catwalk_fade
        add "#402040cc"
        vbox align .5,.2 spacing 8:
            text item.name align .5,.5
            add item.image at zoom(8, True) align .5,.5
            text item.info align .5,.5
            button:
                background "#402040cc" padding 20,20 align .5,.5
                text "Nyaa"
                action Function(g.use_item, item)
transform catwalk_fade:
    alpha 0
    ease .4 alpha 1
transform catwalk_vs_animation:
    alpha 0
    ease .4 alpha 1
    pause 2
    ease .4 alpha 0
transform dice_move(x,y,a):
    parallel:
        easein_elastic .4 xoffset x yoffset y
    parallel:
        pause .2
        ease .2 alpha a
transform catwalk_pound_offset(y):
    subpixel True
    ease 2 yoffset y

init:
    image catwalk_pound_left = Crop((0,0,32,128), "catwalk/catwalk.png")
    image catwalk_pound_right = Crop((320,0,32,128), "catwalk/catwalk.png")
    image catwalk_pound_middle = Crop((32,92,288,32), "catwalk/catwalk.png")

    image catwalk_box = Crop((32,0,32,32), "catwalk/catwalk.png")
    image catwalk_tuna = Crop((64,0,32,32), "catwalk/catwalk.png")
    image catwalk_ball = Crop((96,0,32,32), "catwalk/catwalk.png")
    image catwalk_fight = Crop((128,0,32,32), "catwalk/catwalk.png")
    image catwalk_tile = Crop((32,32,32,32), "catwalk/catwalk.png")
    image catwalk_cucumber = Crop((64,32,32,32), "catwalk/catwalk.png")
    image catwalk_cactus = Crop((96,32,32,32), "catwalk/catwalk.png")
    image catwalk_scratch_post = Crop((128,32,32,32), "catwalk/catwalk.png")

    image catwalk_vs = Crop((160,0,32,32), "catwalk/catwalk.png")

    image catwalk_sandy = Crop((192,0,16,16), "catwalk/catwalk.png")
    image catwalk_kuro = Crop((208,0,16,16), "catwalk/catwalk.png")
    image catwalk_princess = Crop((224,0,16,16), "catwalk/catwalk.png")
    image catwalk_bambino = Crop((240,0,16,16), "catwalk/catwalk.png")

    image catwalk_dice_6 = Crop((256,0,16,16), "catwalk/catwalk.png")
    image catwalk_dice_4 = Crop((272,0,16,16), "catwalk/catwalk.png")
    image catwalk_dice_2 = Crop((288,0,16,16), "catwalk/catwalk.png")
    image catwalk_dice_5 = Crop((256,16,16,16), "catwalk/catwalk.png")
    image catwalk_dice_3 = Crop((272,16,16,16), "catwalk/catwalk.png")
    image catwalk_dice_1 = Crop((288,16,16,16), "catwalk/catwalk.png")

    default catwalk_box = catwalk_item("Box", "catwalk_box", "A shuttle to ride through space and time. Lands at a random tile.")
    default catwalk_tuna = catwalk_item("Tuna", "catwalk_tuna", "Tasty tuna, +50 health. Or +10 max health if full.")
    default catwalk_ball = catwalk_item("Ball", "catwalk_ball", "Time to unravel the mysteries of universe. Stop advancing at this point.")
    default catwalk_fight = catwalk_item("Fight", "catwalk_fight", "Competition is not tolerated.")
    default catwalk_cucumber = catwalk_item("Short snake", "catwalk_cucumber", "Must be avoided at all cost, jump back 10 tiles.")
    default catwalk_cactus = catwalk_item("Ouchy plant", "catwalk_cactus", "It hurts to touch.")
    default catwalk_scratch_post = catwalk_item("Scratchy", "catwalk_scratch_post", "Sharpen your claws. Adds damage")

    default catwalk_sandy = catwalk_cat("Sandy", "catwalk_sandy")
    default catwalk_kuro = catwalk_cat("Kuro", "catwalk_kuro")
    default catwalk_princess = catwalk_cat("Princess", "catwalk_princess")
    default catwalk_bambino = catwalk_cat("Bambino", "catwalk_bambino")

    default catwalk_1 = catwalk_class(
        tiles = [
            catwalk_tile(0,0, "catwalk_tile", "Start"),
            catwalk_tile(0,-1, "catwalk_tile"),
            catwalk_tile(1,-1, "catwalk_tile"),
            catwalk_tile(2,-1, "catwalk_tile"),
            catwalk_tile(3,-1, "catwalk_tile"),
            catwalk_tile(4,-1, "catwalk_tile"),
            catwalk_tile(4,-2, "catwalk_tile"),
            catwalk_tile(4,-3, "catwalk_tile"),
            catwalk_tile(3,-3, "catwalk_tile"),
            catwalk_tile(2,-3, "catwalk_tile"),
            catwalk_tile(1,-3, "catwalk_tile"),
            catwalk_tile(0,-3, "catwalk_tile"),
            catwalk_tile(-1,-3, "catwalk_tile"),
            catwalk_tile(-2,-3, "catwalk_tile"),
            catwalk_tile(-2,-4, "catwalk_tile"),
            catwalk_tile(-3,-4, "catwalk_tile"),
            catwalk_tile(-4,-4, "catwalk_tile"),
            catwalk_tile(-4,-5, "catwalk_tile"),
            catwalk_tile(-4,-6, "catwalk_tile"),
            catwalk_tile(-3,-6, "catwalk_tile"),
            catwalk_tile(-3,-7, "catwalk_tile"),
            catwalk_tile(-3,-8, "catwalk_tile"),
            catwalk_tile(-2,-8, "catwalk_tile"),
            catwalk_tile(-1,-8, "catwalk_tile"),
            catwalk_tile(-0,-8, "catwalk_tile"),
            catwalk_tile(-0,-9, "catwalk_tile"),
            catwalk_tile(1,-9, "catwalk_tile"),
            catwalk_tile(2,-9, "catwalk_tile"),
            catwalk_tile(3,-9, "catwalk_tile"),
            catwalk_tile(4,-9, "catwalk_tile"),
            catwalk_tile(4,-10, "catwalk_tile"),
            catwalk_tile(4,-11, "catwalk_tile"),
            catwalk_tile(4,-12, "catwalk_tile"),
            catwalk_tile(3,-12, "catwalk_tile"),
            catwalk_tile(2,-12, "catwalk_tile"),
            catwalk_tile(1,-12, "catwalk_tile"),
            catwalk_tile(1,-13, "catwalk_tile"),
            catwalk_tile(1,-14, "catwalk_tile"),
            catwalk_tile(0,-14, "catwalk_tile"),
            catwalk_tile(0,-15, "catwalk_tile"),
            catwalk_tile(0,-16, "catwalk_tile"),
            catwalk_tile(0,-17, "catwalk_tile"),
            catwalk_tile(0,-18, "catwalk_tile", "Boss"),
        ],
        items = [
            [4, catwalk_box],
            [4, catwalk_tuna],
            [3, catwalk_ball],
            [4, catwalk_fight],
            [2, catwalk_cucumber],
            [3, catwalk_cactus],
            [2, catwalk_scratch_post],
        ],
        all_cats = [
            catwalk_sandy,
            catwalk_kuro,
            catwalk_princess,
            catwalk_bambino,
        ]
        )


label catwalk_example:
    call screen catwalk_choice(catwalk_1)
    call screen catwalk_screen(catwalk_1)